extern crate lru_cache;
extern crate hyper;
extern crate select;

pub mod pirates;
pub mod ninjas;
mod parser;

#[derive(Debug)]
pub enum Error {
    Http(hyper::error::Error),
    Io(std::io::Error),
    Parse(String)
}

impl From<hyper::error::Error> for Error {
    fn from (err: hyper::error::Error) -> Error {
        Error::Http(err)
    }
}

impl From<std::io::Error> for Error {
    fn from (err: std::io::Error) -> Error {
        Error::Io(err)
    }
}

impl From<std::num::ParseIntError> for Error {
    fn from (err: std::num::ParseIntError) -> Error {
        Error::Parse(format!("{}", err))
    }
}

pub trait Fighter {
    fn power (&self) -> u8;
}
